(function () {
    var factory = function (exports) {
        var $ = jQuery; // if using module loader(Require.js/Sea.js).

        exports.fn.cnbInsertCollapsibleCodeBlock = function () {
            var classPrefix = this.classPrefix;
            var pluginName = "cnb-insert-collapsible-code-block";
            var cm = this.cm;
            var editor = this.editor;
            var prefix = "<details>\n<summary>点击查看代码</summary>\n\n```\n";
            var suffix = "\n```\n</details>";
            var selection = cm.getSelection() || "";
            var replacedContent = function () {
                return prefix + selection + suffix;
            };
            var cursor = Object.assign({}, cm.getCursor());
            if (selection.endsWith("\n")) {
                selection = selection.substring(0, selection.length - 1);
                cursor.line -= 1;
                cm.replaceSelection("\n", "start");
            }
            var preLineContent =
                cursor.line > 0 ? cm.getLine(cursor.line - 1) || "" : "";
            var lineContent = cm.getLine(cursor.line) || "";
            var nextLineContent = cm.getLine(cursor.line + 1) || "";
            if (
                lineContent &&
                selection !==
                (lineContent.endsWith("\n")
                    ? lineContent.substring(0, lineContent.length - 1)
                    : lineContent)
            ) {
                cm.setCursor(cursor.line, lineContent.length);
                cm.replaceSelection("\n");
                cursor = cm.getCursor();
                lineContent = cm.getLine(cursor.line);
                nextLineContent = cm.getLine(cursor.line + 1);
                preLineContent =
                    cursor.line > 0 ? cm.getLine(cursor.line - 1) || "" : "";
            }
            if (preLineContent) prefix = "\n" + prefix;

            cm.replaceSelection(replacedContent());
            cursor = cm.getCursor();
            nextLineContent = cm.getLine(cursor.line + 1);
            if (nextLineContent || nextLineContent === undefined)
                cm.replaceSelection("\n");
            cm.setCursor(
                cursor.line - suffix.split("\n").length + 1,
                selection.length
            );
            if (this.save) this.save();
        };
    };

    // CommonJS/Node.js
    if (
        typeof require === "function" &&
        typeof require === "function" &&
        typeof exports === "object" &&
        typeof module === "object"
    ) {
        module.exports = factory;
    } else {
        factory(window.editormd);
    }
})();
